diff --git a/src/arch/linux/async/signal.c b/src/arch/linux/async/signal.c
index 4719dd60ae..9f96708b33 100644
--- a/src/arch/linux/async/signal.c
+++ b/src/arch/linux/async/signal.c
@@ -876,13 +876,8 @@ static void SIGALRM_call(void *arg)
   /* update mouse cursor before updating the screen */
   mouse_curtick();
 
-  if (video_initialized) {
-    if (Video->update_screen)
-      Video->update_screen();
-    if (Video->handle_events)
-      Video->handle_events();
+  if (video_initialized)
     update_screen();
-  }
 
   /* for the SLang terminal we'll delay the release of shift, ctrl, ...
      keystrokes a bit */
diff --git a/src/base/video/render.c b/src/base/video/render.c
index fd543839e3..b9140a8ca2 100644
--- a/src/base/video/render.c
+++ b/src/base/video/render.c
@@ -27,6 +27,7 @@ struct rmcalls_wrp {
 static struct rmcalls_wrp rmcalls[MAX_REMAPS];
 static int num_remaps;
 static int is_updating;
+static pthread_mutex_t upd_mtx = PTHREAD_MUTEX_INITIALIZER;
 static pthread_t render_thr;
 static pthread_mutex_t render_mtx = PTHREAD_MUTEX_INITIALIZER;
 static sem_t render_sem;
@@ -65,10 +66,8 @@ static void render_lock(void)
 static void render_unlock(void)
 {
   int i;
-  for (i = 0; i < Render.num_renders; i++) {
-    Render.render[i]->unlock(Render.rects[i].rects, Render.rects[i].num_rects);
-    Render.rects[i].num_rects = 0;
-  }
+  for (i = 0; i < Render.num_renders; i++)
+    Render.render[i]->unlock();
   Render.render_locked--;
 }
 
@@ -118,6 +117,19 @@ static void render_text_unlock(void *opaque)
 #endif
 }
 
+static void render_update_end(void)
+{
+  int i;
+  for (i = 0; i < Render.num_renders; i++) {
+    assert(Render.rects[i].num_rects == 0 || Render.render[i]->update);
+    if (Render.rects[i].num_rects) {
+      Render.render[i]->update(Render.rects[i].rects,
+          Render.rects[i].num_rects);
+      Render.rects[i].num_rects = 0;
+    }
+  }
+}
+
 static void render_rect_add(int rend_idx, RectArea rect)
 {
   struct rect_list *rl;
@@ -451,18 +463,24 @@ static void update_graphics_screen(void)
 
 int render_is_updating(void)
 {
-  return is_updating;
+  int upd;
+  pthread_mutex_lock(&upd_mtx);
+  upd = is_updating;
+  pthread_mutex_unlock(&upd_mtx);
+  return upd;
 }
 
 static void *render_thread(void *arg)
 {
   while (1) {
     sem_wait(&render_sem);
+    pthread_mutex_lock(&upd_mtx);
+    is_updating = 1;
+    pthread_mutex_unlock(&upd_mtx);
     pthread_setcancelstate(PTHREAD_CANCEL_DISABLE, NULL);
     vga_emu_update_lock();
     if(vga.reconfig.mem || vga.reconfig.dac)
       modify_mode();
-    is_updating = 1;
     switch (vga.mode_class) {
     case TEXT:
       blink_cursor();
@@ -483,9 +501,11 @@ static void *render_thread(void *arg)
       v_printf("VGA not yet initialized\n");
       break;
     }
-    is_updating = 0;
     vga_emu_update_unlock();
     pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, NULL);
+    pthread_mutex_lock(&upd_mtx);
+    is_updating = 0;
+    pthread_mutex_unlock(&upd_mtx);
     /* small delay til we have a controlled framerate */
     usleep(5000);
   }
@@ -522,11 +542,22 @@ int render_update_vidmode(void)
  */
 int update_screen(void)
 {
+  int upd = render_is_updating();
+
+  if (!upd) {
+    render_update_end();
+    if (Video->update_screen)
+      Video->update_screen();
+  }
+
+  if (Video->handle_events)
+    Video->handle_events();
+
   if(vga.config.video_off) {
     v_printf("update_screen: nothing done (video_off = 0x%x)\n", vga.config.video_off);
     return 1;
   }
-  if (is_updating)
+  if (upd)
     return 1;
   /* unfortunately SDL is not thread-safe, so display mode updates
    * need to be done from main thread. */
@@ -541,6 +572,7 @@ int update_screen(void)
     vga.reconfig.display = 0;
     vga_emu_update_unlock();
   }
+
   sem_post(&render_sem);
   return 1;
 }
diff --git a/src/include/render.h b/src/include/render.h
index 11d58fe68a..d2d8fc2422 100644
--- a/src/include/render.h
+++ b/src/include/render.h
@@ -15,7 +15,8 @@ struct render_system
 {
   void (*refresh_rect)(int x, int y, unsigned width, unsigned height);
   struct bitmap_desc (*lock)(void);
-  void (*unlock)(RectArea *rects, int num_rects);
+  void (*unlock)(void);
+  void (*update)(RectArea *rects, int num_rects);
 };
 
 int register_render_system(struct render_system *render_system);
diff --git a/src/plugin/X/X.c b/src/plugin/X/X.c
index eed0489689..32d9cca68d 100644
--- a/src/plugin/X/X.c
+++ b/src/plugin/X/X.c
@@ -454,7 +454,7 @@ static void X_show_mouse_cursor(int yes);
 static void X_set_mouse_cursor(int yes, int mx, int my, int x_range, int y_range);
 static struct bitmap_desc X_lock_canvas(void);
 static void X_lock(void);
-static void X_unlock_canvas(RectArea *rects, int num_rects);
+static void X_unlock_canvas(void);
 static void X_unlock(void);
 
 void kdos_recv_msg(char *);
@@ -1358,7 +1358,7 @@ static void X_unlock(void)
   XUnlockDisplay(display);
 }
 
-static void X_unlock_canvas(RectArea *rects, int num_rects)
+static void X_unlock_canvas(void)
 {
   X_unlock();
 }
diff --git a/src/plugin/sdl/sdl.c b/src/plugin/sdl/sdl.c
index 8f9fbd9a4b..7ebaedb5fd 100644
--- a/src/plugin/sdl/sdl.c
+++ b/src/plugin/sdl/sdl.c
@@ -68,7 +68,8 @@ static int SDL_change_config(unsigned, void *);
 static void toggle_grab(int kbd);
 static void window_grab(int on, int kbd);
 static struct bitmap_desc lock_surface(void);
-static void unlock_surface(RectArea *rects, int num_rects);
+static void unlock_surface(void);
+static void update_surface(RectArea *rects, int num_rects);
 
 static struct video_system Video_SDL = {
   SDL_priv_init,
@@ -86,6 +87,7 @@ static struct video_system Video_SDL = {
 static struct render_system Render_SDL = {
   .lock = lock_surface,
   .unlock = unlock_surface,
+  .update = update_surface,
 };
 
 static SDL_Renderer *renderer;
@@ -351,11 +353,15 @@ static struct bitmap_desc lock_surface(void)
   return BMP(pixels, win_width, win_height, pitch);
 }
 
-static void unlock_surface(RectArea *rects, int num_rects)
+static void unlock_surface(void)
 {
-  int i;
   SDL_UnlockTexture(texture);
   pthread_mutex_unlock(&mode_mtx);
+}
+
+static void update_surface(RectArea *rects, int num_rects)
+{
+  int i;
   for (i = 0; i < num_rects; i++) {
     RectArea *r = &rects[i];
     SDL_put_image(r->x, r->y, r->width, r->height);
